import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import handlebars from "handlebars";
import { keyword } from "esutils";
import BaseGenerator from "./BaseGenerator.js";

var TypescriptInterfaceGenerator = /*#__PURE__*/function (_BaseGenerator) {
  _inherits(TypescriptInterfaceGenerator, _BaseGenerator);

  var _super = _createSuper(TypescriptInterfaceGenerator);

  function TypescriptInterfaceGenerator(params) {
    var _this;

    _classCallCheck(this, TypescriptInterfaceGenerator);

    _this = _super.call(this, params);

    _this.registerTemplates("typescript/", ["interface.ts"]);

    handlebars.registerHelper("isIdentifier", function (name) {
      return keyword.isIdentifierES5(name);
    });
    return _this;
  }

  _createClass(TypescriptInterfaceGenerator, [{
    key: "help",
    value: function help(resource) {
      console.log('Interface for the "%s" resource type has been generated!', resource.title);
    }
  }, {
    key: "generate",
    value: function generate(api, resource, dir) {
      var dest = "".concat(dir, "/interfaces");

      var _this$parseFields = this.parseFields(resource),
          fields = _this$parseFields.fields,
          imports = _this$parseFields.imports;

      var normalizeTypeName = function normalizeTypeName(name) {
        return name.replace(/-/g, "_");
      };

      this.createDir(dest, false);
      this.createFile("interface.ts", "".concat(dest, "/").concat(resource.title.toLowerCase(), ".ts"), {
        fields: fields,
        imports: imports,
        name: normalizeTypeName(resource.title)
      });
    }
  }, {
    key: "getDescription",
    value: function getDescription(field) {
      return field.description ? field.description.replace(/"/g, "'") : "";
    }
  }, {
    key: "parseFields",
    value: function parseFields(resource) {
      var fields = {};

      var _iterator = _createForOfIteratorHelper(resource.writableFields),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var field = _step.value;
          fields[field.name] = {
            notrequired: !field.required,
            name: field.name,
            type: this.getType(field),
            description: this.getDescription(field),
            readonly: false,
            reference: field.reference
          };
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      var _iterator2 = _createForOfIteratorHelper(resource.readableFields),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _field = _step2.value;

          if (fields[_field.name] !== undefined) {
            continue;
          }

          fields[_field.name] = {
            notrequired: !_field.required,
            name: _field.name,
            type: this.getType(_field),
            description: this.getDescription(_field),
            readonly: true,
            reference: _field.reference
          };
        } // Parse fields to add relevant imports, required for Typescript

      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      var fieldsArray = Object.keys(fields).map(function (e) {
        return fields[e];
      });
      var imports = {};

      var _iterator3 = _createForOfIteratorHelper(fieldsArray),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var _field2 = _step3.value;

          if (_field2.reference) {
            imports[_field2.type] = {
              type: _field2.type,
              file: "./" + _field2.type.toLowerCase()
            };
          }
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      var importsArray = Object.keys(imports).map(function (e) {
        return imports[e];
      });
      return {
        fields: fieldsArray,
        imports: importsArray
      };
    }
  }]);

  return TypescriptInterfaceGenerator;
}(BaseGenerator);

export { TypescriptInterfaceGenerator as default };