import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import chalk from "chalk";
import BaseGenerator from "./BaseGenerator.js";

var _default = /*#__PURE__*/function (_BaseGenerator) {
  _inherits(_default, _BaseGenerator);

  var _super = _createSuper(_default);

  function _default(params) {
    var _this;

    _classCallCheck(this, _default);

    _this = _super.call(this, params);

    _this.registerTemplates("common/", [// utils
    "utils/mercure.js"]);

    _this.registerTemplates("vue/", [// modules
    "store/modules/foo/index.js", "store/modules/foo/create/actions.js", "store/modules/foo/create/index.js", "store/modules/foo/create/mutation_types.js", "store/modules/foo/create/mutations.js", "store/modules/foo/delete/actions.js", "store/modules/foo/delete/index.js", "store/modules/foo/delete/mutation_types.js", "store/modules/foo/delete/mutations.js", "store/modules/foo/list/actions.js", "store/modules/foo/list/index.js", "store/modules/foo/list/mutation_types.js", "store/modules/foo/list/mutations.js", "store/modules/foo/show/actions.js", "store/modules/foo/show/index.js", "store/modules/foo/show/mutation_types.js", "store/modules/foo/show/mutations.js", "store/modules/foo/update/actions.js", "store/modules/foo/update/index.js", "store/modules/foo/update/mutation_types.js", "store/modules/foo/update/mutations.js", // components
    "components/foo/Create.vue", "components/foo/Form.vue", "components/foo/List.vue", "components/foo/Update.vue", "components/foo/Show.vue", // mixins
    "mixins/ItemWatcher.js", "mixins/ListWatcher.js", // routes
    "router/foo.js", // error
    "error/SubmissionError.js", // utils
    "utils/fetch.js", "utils/hydra.js"]);

    return _this;
  }

  _createClass(_default, [{
    key: "help",
    value: function help(resource) {
      var titleLc = resource.title.toLowerCase();
      console.log('Code for the "%s" resource type has been generated!', resource.title);
      console.log("Paste the following definitions in your application configuration:");
      console.log(chalk.green("\n//import routes\nimport ".concat(titleLc, "Routes from './router/").concat(titleLc, "';\n\n// Add routes to VueRouter\nconst router = new VueRouter({\n  // ...\n  routes: [\n      ...").concat(titleLc, "Routes,\n  ]\n});\n\n// Add the modules in the store\nimport ").concat(titleLc, " from './store/modules/").concat(titleLc, "/';\n\nexport const store = new Vuex.Store({\n  // ...\n  modules: {\n    ").concat(titleLc, "\n  }\n});\n")));
    }
  }, {
    key: "generate",
    value: function generate(api, resource, dir) {
      var _this2 = this;

      var lc = resource.title.toLowerCase();
      var titleUcFirst = resource.title.charAt(0).toUpperCase() + resource.title.slice(1);
      var context = {
        title: resource.title,
        name: resource.name,
        lc: lc,
        uc: resource.title.toUpperCase(),
        fields: resource.readableFields,
        formFields: this.buildFields(resource.writableFields),
        hydraPrefix: this.hydraPrefix,
        titleUcFirst: titleUcFirst
      }; // Create directories
      // These directories may already exist

      ["".concat(dir, "/config"), "".concat(dir, "/error"), "".concat(dir, "/mixins"), "".concat(dir, "/router"), "".concat(dir, "/utils")].forEach(function (dir) {
        return _this2.createDir(dir, false);
      });
      ["".concat(dir, "/store/modules/").concat(lc), "".concat(dir, "/store/modules/").concat(lc, "/create"), "".concat(dir, "/store/modules/").concat(lc, "/delete"), "".concat(dir, "/store/modules/").concat(lc, "/list"), "".concat(dir, "/store/modules/").concat(lc, "/show"), "".concat(dir, "/store/modules/").concat(lc, "/update"), "".concat(dir, "/components/").concat(lc)].forEach(function (dir) {
        return _this2.createDir(dir);
      });
      [// modules
      "store/modules/%s/index.js", "store/modules/%s/create/actions.js", "store/modules/%s/create/index.js", "store/modules/%s/create/mutation_types.js", "store/modules/%s/create/mutations.js", "store/modules/%s/delete/actions.js", "store/modules/%s/delete/index.js", "store/modules/%s/delete/mutation_types.js", "store/modules/%s/delete/mutations.js", "store/modules/%s/list/actions.js", "store/modules/%s/list/index.js", "store/modules/%s/list/mutation_types.js", "store/modules/%s/list/mutations.js", "store/modules/%s/show/actions.js", "store/modules/%s/show/index.js", "store/modules/%s/show/mutation_types.js", "store/modules/%s/show/mutations.js", "store/modules/%s/update/actions.js", "store/modules/%s/update/index.js", "store/modules/%s/update/mutation_types.js", "store/modules/%s/update/mutations.js", // components
      "components/%s/Create.vue", "components/%s/Form.vue", "components/%s/List.vue", "components/%s/Update.vue", "components/%s/Show.vue", // routes
      "router/%s.js"].forEach(function (pattern) {
        return _this2.createFileFromPattern(pattern, dir, lc, context);
      });

      for (var _i = 0, _arr = ["mixins/ItemWatcher.js", "mixins/ListWatcher.js"]; _i < _arr.length; _i++) {
        var file = _arr[_i];
        this.createFile(file, "".concat(dir, "/").concat(file));
      } // error


      this.createFile("error/SubmissionError.js", "".concat(dir, "/error/SubmissionError.js"), context, false);
      this.createEntrypoint(api.entrypoint, "".concat(dir, "/config/entrypoint.js"));
      this.createFile("utils/fetch.js", "".concat(dir, "/utils/fetch.js"), {
        hydraPrefix: this.hydraPrefix
      }, false);
      this.createFile("utils/hydra.js", "".concat(dir, "/utils/hydra.js"), {
        hydraPrefix: this.hydraPrefix
      }, false);
      this.createFile("utils/mercure.js", "".concat(dir, "/utils/mercure.js"));
    }
  }]);

  return _default;
}(BaseGenerator);

export { _default as default };